using System;
using System.Linq;
namespace Zalba
{
    class Program
    {
        static void Main(string[] args)
        {
            int takmicari = int.Parse(Console.ReadLine());
            for (int i = 0; i < takmicari; i++)
            {
                string[] nm = Console.ReadLine().Split();
                int n = int.Parse(nm[0]);
                int m = int.Parse(nm[1]);

                string[] x = Console.ReadLine().Split();
                long[] primljeno = new long[n];
                for (int j = 0; j < n; j++)
                    primljeno[j] = long.Parse(x[j]);
                Array.Sort(primljeno);

                string[] y = Console.ReadLine().Split();
                long[] odbijeno = new long[m];
                for (int k = 0; k < m; k++)
                    odbijeno[k] = long.Parse(y[k]);
                Array.Sort(odbijeno);

                long razlika = primljeno[1] - primljeno[0], element1 = primljeno.Last(), element2 = primljeno.Last();
                int moze = 1;
                while (element1 > 0 || element2 < odbijeno.Last())
                {
                    if (odbijeno.Contains(element1) || odbijeno.Contains(element2))
                    {
                        moze = 0;
                        break;
                    }
                    element1 -= razlika;
                    element2 += razlika;
                }
                Console.WriteLine(moze);
            }
        }
    }
}